﻿Public Class Form1

  Private WithEvents WPFMAP As ThinkGeo.MapSuite.WpfDesktopEdition.WpfMap

  Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
    init()
  End Sub

  Private Sub init()

    WPFMAP = CtlWPFMap1.WpfMap1

    CtlWPFMap1.WpfMap1.MapUnit = ThinkGeo.MapSuite.Core.GeographyUnit.Meter
    CtlWPFMap1.WpfMap1.ZoomLevelSet = New ThinkGeo.MapSuite.Core.BingMapsZoomLevelSet
    For Each oZooml As ThinkGeo.MapSuite.Core.ZoomLevel In WPFMAP.ZoomLevelSet.GetZoomLevels
      Debug.Print(oZooml.Scale.ToString)
    Next
    Dim a As New ThinkGeo.MapSuite.Core.ZoomLevelSet
    For Each oZooml As ThinkGeo.MapSuite.Core.ZoomLevel In a.GetZoomLevels
      Debug.Print(oZooml.Scale.ToString)
    Next

    'Dim oOSMLayer As New ThinkGeo.MapSuite.Core.BingMapsLayer("")
    Dim oOSMLayer As New ThinkGeo.MapSuite.Core.OpenStreetMapLayer()
    oOSMLayer.CacheDirectory = "c:\Users\t.jeitner\AppData\Local\Temp\TileCache\Bing\"
    'oOSMLayer.MapType = ThinkGeo.MapSuite.Core.BingMapsMapType.Aerial
    Dim oLayerOverlay As New ThinkGeo.MapSuite.WpfDesktopEdition.LayerOverlay
    oLayerOverlay.TileCache = Nothing
    oLayerOverlay.TileType = ThinkGeo.MapSuite.WpfDesktopEdition.TileType.MultipleTile
    oLayerOverlay.Layers.Add("OSM", oOSMLayer)

    Dim oShapeFileLayer As New ThinkGeo.MapSuite.Core.ShapeFileFeatureLayer(System.IO.Path.Combine(System.Environment.CurrentDirectory, "Karten\alk-flurstueck-objekt.shp"))

    Dim oProj As New ThinkGeo.MapSuite.Core.ManagedProj4Projection()
    'oProj.InternalProjectionParametersString = ThinkGeo.MapSuite.Core.ManagedProj4Projection.GetEpsgParametersString(31467)
    oProj.InternalProjectionParametersString = "+proj=tmerc +lat_0=0 +lon_0=9 +k=1 +x_0=3500000 +y_0=0 +ellps=bessel +towgs84=598.1,73.7,418.2,0.202,0.045,-2.455,6.7 +units=m +no_defs"
    oProj.ExternalProjectionParametersString = ThinkGeo.MapSuite.Core.ManagedProj4Projection.GetBingMapParametersString + " +nadgrids=@null"
    'oProj.ExternalProjectionParametersString = "+proj=merc +a=6378137 +b=6378137 +lat_ts=0.0 +lon_0=0.0 +x_0=0.0 +y_0=0 +k=1.0 +units=m +nadgrids=@null +no_defs"
    oProj.Open()
    oShapeFileLayer.FeatureSource.Projection = oProj
    oShapeFileLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = ThinkGeo.MapSuite.Core.AreaStyles.CreateSimpleAreaStyle(ThinkGeo.MapSuite.Core.GeoColor.SimpleColors.Transparent, ThinkGeo.MapSuite.Core.GeoColor.SimpleColors.DarkBlue, 1)
    oShapeFileLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ThinkGeo.MapSuite.Core.ApplyUntilZoomLevel.Level20

    Dim oLayerOverlay2 As New ThinkGeo.MapSuite.WpfDesktopEdition.LayerOverlay
    oLayerOverlay2.TileCache = Nothing
    oLayerOverlay2.Layers.Add(oShapeFileLayer)
    oLayerOverlay2.TileType = ThinkGeo.MapSuite.WpfDesktopEdition.TileType.MultipleTile

    CtlWPFMap1.WpfMap1.MapUnit = ThinkGeo.MapSuite.Core.GeographyUnit.Meter

    CtlWPFMap1.WpfMap1.Overlays.Add("OSM", oLayerOverlay)
    CtlWPFMap1.WpfMap1.Overlays.Add(oLayerOverlay2)
    oShapeFileLayer.Open()

    CtlWPFMap1.WpfMap1.CurrentExtent = New ThinkGeo.MapSuite.Core.RectangleShape("POLYGON((934648.203638525 6273869.82935234,940759.099560311 6273869.82935234,940759.099560311 6262785.35823625,934648.203638525 6262785.35823625,934648.203638525 6273869.82935234))") ' oShapeFileLayer.GetBoundingBox
    CtlWPFMap1.WpfMap1.Refresh()

  End Sub

  Private Sub WPFMAP_CurrentScaleChanged(ByVal sender As Object, ByVal e As ThinkGeo.MapSuite.WpfDesktopEdition.CurrentScaleChangedWpfMapEventArgs) Handles WPFMAP.CurrentScaleChanged
    Me.Text = "Scale: " + e.CurrentScale.ToString
  End Sub

  Private Sub ToolStripButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton1.Click

    Dim oLayerOverlay As ThinkGeo.MapSuite.WpfDesktopEdition.LayerOverlay = WPFMAP.Overlays("OSM")
    If ToolStripButton1.Checked Then
      oLayerOverlay.TileCache = New ThinkGeo.MapSuite.Core.FileBitmapTileCache(System.IO.Path.Combine(System.IO.Path.GetTempPath, "TileCache\OSM"))
    Else
      oLayerOverlay.TileCache = Nothing
    End If
    oLayerOverlay.Refresh()

  End Sub

  Private Sub ToolStripButton2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton2.Click
    If ToolStripButton2.Checked Then
      DirectCast(WPFMAP.Overlays("OSM"), ThinkGeo.MapSuite.WpfDesktopEdition.LayerOverlay).TileType = ThinkGeo.MapSuite.WpfDesktopEdition.TileType.SingleTile
    Else
      DirectCast(WPFMAP.Overlays("OSM"), ThinkGeo.MapSuite.WpfDesktopEdition.LayerOverlay).TileType = ThinkGeo.MapSuite.WpfDesktopEdition.TileType.MultipleTile
    End If
  End Sub

  Private Sub WPFMAP_OverlayDrawing(ByVal sender As Object, ByVal e As ThinkGeo.MapSuite.WpfDesktopEdition.OverlayDrawingWpfMapEventArgs) Handles WPFMAP.OverlayDrawing

  End Sub

  Private Sub WPFMAP_OverlaysDrawing(ByVal sender As Object, ByVal e As ThinkGeo.MapSuite.WpfDesktopEdition.OverlaysDrawingWpfMapEventArgs) Handles WPFMAP.OverlaysDrawing

  End Sub

  Private Sub ToolStripButton3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton3.Click
    WPFMAP.Refresh(WPFMAP.Overlays("OSM"))
    WPFMAP.Overlays("OSM").Refresh()
  End Sub


End Class
